CRUDpaketmakan/urls.py
from django.urls import path
from .views import *

app_name = 'CRUDpaketmakan'
urlpatterns = [
	path('create_paket_makan', createpaketmakan, name='createpaketmakan'),
    path('list_paket_makan', listpaketmakan, name='listpaketmakan'),
    path('delete_paket_makan/<str:kode_hotel>/<str:kode_paket>', deletepaketmakan, name='deletepaketmakan'),
    path('update_paket_makan/<str:kode_hotel>/<str:kode_paket>', updatepaketmakan, name='updatepaketmakan'),
]

dashboard/urls.py
from django.urls import path
from .views import *

app_name = 'dashboard'
urlpatterns = [
	path('dashboard', dashboard, name='dashboard')
]

login/urls.py
from django.urls import path
from .views import *

app_name = 'login'
urlpatterns = [
	path('register_admin', register_admin, name='register_admin'),
	path('register_penggunapublik',register_penggunapublik, name='register_penggunapublik'),
    path('register_dokter',register_dokter, name='register_dokter'),
    path('register_adminsatgas',register_adminsatgas, name='register_adminsatgas'),
    path('login_user', login_user, name='login_user'),
    path('logout_user', logout_user, name='logout_user')
]

siruco/urls.py
from django.contrib import admin
from django.urls import path,include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('homepage.urls')),
    path('', include('login.urls')),
    path('', include('dashboard.urls')),
    path('', include('CRUDpasien.urls')),
    path('', include('CRUDpaketmakan.urls')),
    path('', include('CRUhotel.urls')),
    path('', include('rumah_sakit.urls')),
    path('', include('transaksi.urls')),
    path('', include('faskes.urls')),
    path('', include('appointment.urls')),
    path('', include('jadwaldokter.urls')),
    path('', include('ruanganbedRS.urls')),
]

CRUDpaketmakan/models.py
from django.db import models

# Create your models here.

CRUDpaketmakan/forms.py
from django import forms
from django.db import connection

class FormCreatePaketMakan(forms.Form):
    cursor = connection.cursor()
    cursor.execute("SET SEARCH_PATH TO SIRUCO")
    cursor.execute("""SELECT KodeHotel FROM HOTEL_ROOM""")
    results = cursor.fetchall()
    cursor.close()
    connection.close()
    kode = []
    for row in results:
        kode.append(row[0])
    
    kode_hotel = []
    for value in kode:
        kode_hotel.append((value,value))

    kodeHotel = forms.ChoiceField(label=("Kode Hotel:"),
                                    choices = kode_hotel,
                                    widget = forms.Select({'class':'form-control'}))
    kode_paket= forms.CharField(label='Kode Paket',max_length=20)
    nama_paket=forms.CharField(label='Nama Paket',max_length=50)
    harga=forms.CharField(label='Harga', max_length=20)

class FormUpdatePaketMakan(forms.Form):
    kodeHotel = forms.CharField(label='Kode Hotel',max_length=20, disabled=(True))
    kode_paket = forms.CharField(label='Kode Paket',max_length=20, disabled=(True))
    nama_paket = forms.CharField(label='Nama Paket',max_length=50)
    harga = forms.CharField(label='Harga', max_length=20)

CRUDpaketmakan/views.py
from django.shortcuts import render, redirect
from django.db import connection
from django.http import HttpResponseRedirect
from django.urls import reverse
from django.contrib import messages
from .forms import *
from django.forms import inlineformset_factory, modelformset_factory
from django.contrib.auth import authenticate, login, logout
from django.db import DatabaseError, transaction
from collections import namedtuple

def namedtuplefetchall(cursor):
    "Return all rows from a cursor as a namedtuple"
    desc = cursor.description
    nt_result = namedtuple('Result', [col[0] for col in desc])
    return [nt_result(*row) for row in cursor.fetchall()]

def updatepaketmakan(request, kode_hotel, kode_paket):
    kode_hotel = str(kode_hotel)
    kode_paket = str(kode_paket)
    cursor = connection.cursor()
    cursor.execute("SET SEARCH_PATH TO SIRUCO")
    cursor.execute("SELECT * FROM PAKET_MAKAN WHERE kodehotel = '"+kode_hotel+"' and kodepaket = '"+kode_paket+"'")
    hasil = namedtuplefetchall(cursor)
    nama_paket = hasil[0].nama
    harga_paket = hasil[0].harga
    form = FormUpdatePaketMakan(initial={
        'kodeHotel': kode_hotel, 'kode_paket': kode_paket, 'nama_paket': nama_paket, 'harga' : harga_paket })
    
    if request.method == 'POST':
        nama_paket = request.POST['nama_paket']
        harga_paket= request.POST['harga']
        try :
            cursor.execute("UPDATE PAKET_MAKAN SET nama ='"+nama_paket+"', harga ='"+harga_paket+"' WHERE kodehotel ='"+kode_hotel+"' and kodepaket ='"+kode_paket+"'")
            cursor.close()
            return redirect('/list_paket_makan')
        except Exception as e:
            message = str(e)[80:]
            
    response = {
        'form' : form,
        'message' : message
    }
    return render(request, "update_paket_makan.html", response)


def deletepaketmakan(request, kode_hotel, kode_paket):
    kode_hotel = str(kode_hotel)
    kode_paket = str(kode_paket)
    cursor = connection.cursor()
    cursor.execute("SET SEARCH_PATH TO SIRUCO")
    if check_paket_makan(kode_hotel, kode_paket) == True :
        return redirect('/list_paket_makan')
    else :   
        cursor.execute("DELETE FROM PAKET_MAKAN WHERE kodehotel = '"+kode_hotel+"' AND kodepaket = '"+kode_paket+"' ")
    cursor.close()
    messages.success(request, "Data PaketMakan berhasil terhapus")
    return HttpResponseRedirect(reverse('CRUDpaketmakan:listpaketmakan'))

def listpaketmakan(request):
    cursor = connection.cursor()
    roleAdmin = False

    try:
        if (request.session['role'] == 'admin'):
            roleAdmin = True
        
    except:
        return redirect('/')

    cursor.execute("SET SEARCH_PATH TO SIRUCO")
    cursor.execute("SELECT * FROM PAKET_MAKAN")
    hasil = dictfetchall(cursor)
    # cursor.execute("SELECT * FROM PAKET_MAKAN WHERE kodehotel in (SELECT kodehotel FROM DAFTAR_PESAN) AND kodepaket in (SELECT kodepaket FROM DAFTAR_PESAN)")
    # results = cursor.fetchall()
    # kode = []
    # for row in results:
    #     kode.append((row[0],row[1]))
    # print(kode)
    # cursor.execute("SELECT * FROM PAKET_MAKAN")
    # result = cursor.fetchall()
    # j = []
    # for i in result :
    #     j.append((i[0],i[1]))
    # print(j)
    cursor.close()
    response = {
        'list' : hasil,
        'roleAdmin' : roleAdmin,
        # 'kode' : kode
    }
    return render(request, "list_paket_makan.html", response)

def createpaketmakan(request):
    try:
        if request.method == 'POST':
            registform = FormCreatePaketMakan(request.POST)
            if registform.is_valid():
                kodeHotel = registform.cleaned_data['kodeHotel']
                kode_paket= registform.cleaned_data['kode_paket']
                nama_paket = registform.cleaned_data['nama_paket']
                harga= registform.cleaned_data['harga']

                if check_paket_makan_is_exist(kodeHotel, kode_paket) == False:
                    with connection.cursor() as c:
                        c.execute("INSERT INTO PAKET_MAKAN VALUES (%s, %s, %s, %s)",[kodeHotel, kode_paket, nama_paket, harga])
                    return HttpResponseRedirect(reverse('CRUDpaketmakan:listpaketmakan')) # CHANGE TO DESIRED APP
                else:
                    messages.error(request, 'Data paket makan sudah terdaftar')
                    return HttpResponseRedirect('/list_paket_makan')
                    messages.error(request, 'Data paket makan sudah terdaftar')
    except DatabaseError:
        print("2") #cek terminal, masuk ga ini
        messages.error(request, "Data yang diisikan belum lengkap, silahkan lengkapi data terlebih dahulu") # kenapa ga muncul ya
        return HttpResponseRedirect('/create_pasien_makan')
    register_form = FormCreatePaketMakan(request.POST)
    response = {'register_paket_makan':register_form}
    return render(request,'create_paket_makan.html',response)

def check_paket_makan_is_exist(kode_hotel, kode_paket):
    data = {}
    with connection.cursor() as c:
        c.execute("SET SEARCH_PATH TO SIRUCO")
        c.execute("SELECT * FROM PAKET_MAKAN where kodehotel = %s AND kodepaket = %s",[kode_hotel, kode_paket])
        
        data = dictfetchall(c)
    return len(data) > 0 

def check_paket_makan(kode_hotel, kode_paket):
    data = {}
    with connection.cursor() as c:
        c.execute("SET SEARCH_PATH TO SIRUCO")
        c.execute("SELECT * FROM DAFTAR_PESAN where kodehotel = %s AND kodepaket = %s",[kode_hotel, kode_paket])
        
        data = dictfetchall(c)
    return len(data) > 0 

def dictfetchall(cursor):
    "Return all rows from a cursor as a dict"
    columns = [col[0] for col in cursor.description]
    return [
        dict(zip(columns, row))
        for row in cursor.fetchall()
    ]





CRUDpaketmakan/templates/create_paket_makan.html
{% extends "dashboard_admin.html" %}
{% load static %}
{% block content %}
</div>
    <form action='' method="POST" class="form-group" style="background-color: aliceblue;margin-top: 100px;">
        {% csrf_token %}
        {% for field in register_paket_makan %}
        <div class="form-group">
            {{ field.label_tag }} {{ field }}
        </div>
        {% endfor %}
        <div class="centre-items">
            <input type="submit" class="btn btn-primary" value="SIMPAN">
        </div>
    </form>
</div>
{% endblock %}

CRUDpaketmakan/templates/list_paket_makan.html
{% load static %}
<!doctype html>
<html lang="en">
  <head>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <!-- Optional JavaScript -->
      <!-- jQuery first, then Popper.js, then Bootstrap JS -->
      <script src="https://code.jquery.com/jquery-3.4.1.min.js"></script>
      <script src="https://code.jquery.com/jquery-3.5.1.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
      <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.1/dist/umd/popper.min.js" integrity="sha384-9/reFTGAW83EW2RDu2S0VKaIzap3H66lZH81PoYlFhbGU+6BZp6G7niu735Sk7lN" crossorigin="anonymous"></script>
      <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js" integrity="sha384-B4gt1jrGC7Jh4AgTPSdUtOBvfO8shuf57BaghqFfPlYxofvL8/KUEfYiJOMMV+rV" crossorigin="anonymous"></script>
      <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
      <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/js/bootstrap.min.js"></script>
      
    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css">
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css" integrity="sha384-JcKb8q3iqJ61gNV9KGb8thSsNjpSL0n8PARn9HuZOnIxN0hoP+VmmDGMN5t9UJ0Z" crossorigin="anonymous">
    <link rel="stylesheet" href="{% static 'dashboard/style.css' %}">
    
  </head>
  <body>
    <div class="fixed-top" style="background: rgb(239, 240, 245);">
    <nav class="navbar navbar-expand-lg navbar-light bg-light" style="background-color:rgb(69, 76, 95);">
        <a class="fa fa-strikethrough" style="font-size:40px;color: rgb(238, 234, 235);"></a>
        <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNav" aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
          <span class="navbar-toggler-icon"></span>
        </button>
        <div class="collapse navbar-collapse" id="navbarNav">
          <ul class="navbar-nav">
            <li class="nav-item">
                <a class="nav-link" href="#" style="margin-left:0px;margin-right:0px;font-size: 20px;color:black">PAKET MAKAN</a>
              </li>
          </ul>
        </div>
      </nav>
    </div>

      <div style="margin-top: 100px;">
        <h1 class="list_title">Daftar Paket Makan</h1>
        <h2 class="message">{{message}}</h2>
        <div class="table-responsive">
          <table class="table table-hover" style="width:60%; margin-left:20%;">
              <thead>
              <tr class="table-light" style="text-align: center;">
                  <th scope="col">Hotel</th>
                  <th scope="col">Kode Paket</th>
                  <th scope="col">Nama Paket</th>
                  <th scope="col">Harga</th>
                  {% if roleAdmin %}
                  <th scope="col" colspan="2">Action</th>
                    {% endif %}
                </tr>
              </thead>
              <tbody>
                  {% for paket in list %}
                <tr class="table-light" style="text-align: center;">
                  <th scope="row">{{paket.kodehotel}}</th>
                  <th scope="row">{{paket.kodepaket}}</th>
                  <th scope="row">{{paket.nama}}</th>
                  <th scope="row">Rp{{paket.harga}}</th>
                  {% if roleAdmin %}
                  <th scope="row"><a class="btn btn-info" href="{% url 'CRUDpaketmakan:updatepaketmakan' paket.kodehotel paket.kodepaket %}">Update</a></th>
                  <th scope="row"><a class="btn btn-danger" href="{% url 'CRUDpaketmakan:deletepaketmakan' paket.kodehotel paket.kodepaket %}">Delete</a></th>
                  {% endif %}
                </tr>
                {% endfor %}
              </tbody>
            </table>
            <a class="btn btn-info" href="{% url 'dashboard:dashboard'%}">Kembali</a></th>
          </div>
      </div>
    
    </body>
    </html>

CRUDpaketmakan/templates/update_paket_makan.html
{% extends "dashboard_admin.html" %}
{% load static %}
{% block content %}
</div>
    <form action='' method="POST" class="form-group" style="background-color: aliceblue;margin-top: 100px;">
        {% csrf_token %}
        {% for field in form %}
        <div class="form-group">
            {{ field.label_tag }} {{ field }}
        </div>
        {% endfor %}
        <div class="centre-items">
            <input type="submit" class="btn btn-primary" value="UPDATE">
        </div>
    </form>
</div>
{% endblock %}